
#if !defined(AFX_TAPICTL_H__5B40BA77_CC47_11D4_8A39_0050DACF7F4C__INCLUDED_)
#define AFX_TAPICTL_H__5B40BA77_CC47_11D4_8A39_0050DACF7F4C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "tapi.h"
#include "Mmsystem.h"
#include <afxtempl.h>


typedef struct MYWAVEDATA_tag
{
	WAVEHDR wavehdr;
	PWAVEFORMATEX waveformat;
} MYWAVEDATA, *PMYWAVEDATA;


CArray<PMYWAVEDATA ,PMYWAVEDATA> m_PlayData; //   


// TapiCtl.h : Declaration of the CTapiCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CTapiCtrl : See TapiCtl.cpp for implementation.

class CTapiCtrl : public COleControl
{
	DECLARE_DYNCREATE(CTapiCtrl)

// Constructor
public:
	CTapiCtrl();
    static void CALLBACK lineCallbackFunc(
        DWORD dwDevice, DWORD dwMsg, DWORD dwCallbackInstance, 
        DWORD dwParam1, DWORD dwParam2, DWORD dwParam3);
	
	static void CALLBACK waveOutProc(
		HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, 
		DWORD dwParam1, DWORD dwParam2);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTapiCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	//}}AFX_VIRTUAL

// Implementation
protected:
	PMYWAVEDATA LoadWaveInfo(LPCTSTR strFileName); //   
	LPLINEDEVCAPS MylineGetDevCaps(HLINEAPP hLineApp,LPLINEDEVCAPS lpLineDevCaps, DWORD dwDeviceID, DWORD dwAPIVersion);
	BOOL HandleLineErr(long lLineErr);//     
	DWORD GetDeviceLine(HLINEAPP hLineApp);
	void HandleLineCallState( DWORD dwDevice, DWORD dwMessage, DWORD dwCallbackInstance, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3);
	long WaitForDialMSG (long lRequestID, long lCodeMSG);
	~CTapiCtrl();
	LONG GetWaveID(HLINE hLine, HCALL hCall, 
		DWORD dwSelect, LPSTR waveDev);//    / 
	long WaitForPlay(long lRequestID);

   	BOOL m_bCallInProgress; //  
	BOOL m_bInitialized;	//TAPI 
    DWORD m_dwDeviceID;		//  
    HLINEAPP m_hLineApp;	//    TAPI
    HCALL m_hCall;			//  
    HLINE m_hLine;			//   
    DWORD m_dwAPIVersion;		//  TAPI 
    HWAVEIN     m_hWaveIn ;	//   
    HWAVEOUT    m_hWaveOut ;	//   
    INT m_iWaveInID;			//   
	INT m_iWaveOutID;			//   
    BOOL m_bInitializing;		//   
    BOOL m_bConnected;	//   
	BOOL m_bLineReply;	//    LINE_REPLY
	DWORD m_dwNumDevs;		//   TAPI
	CString m_strLastMessage; //   
	CString m_strListDevice;	  //  ,   
	long m_WaitTimeOut; //  
	BOOL m_bPlaying; //  ,   

	DECLARE_OLECREATE_EX(CTapiCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CTapiCtrl)      // GetTypeInfo
//	DECLARE_PROPPAGEIDS(CTapiCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CTapiCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CTapiCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CTapiCtrl)
	CString m_lastError;
	afx_msg void OnLastErrorChanged();
	afx_msg BOOL GetTapiInitialize();
	afx_msg void SetTapiInitialize(BOOL bNewValue);
	afx_msg long GetWaitTimeOut();
	afx_msg void SetWaitTimeOut(long nNewValue);
	afx_msg long GetDeviceID();
	afx_msg void SetDeviceID(long nNewValue);
	afx_msg BOOL DialCall(LPCTSTR strNumberCall);
	afx_msg BOOL HangupDial();
	afx_msg BOOL PlayFile(LPCTSTR strFileName);
	afx_msg BOOL AddFileToPlayList(LPCTSTR strFileName);
	afx_msg BOOL ClearPlayList();
	afx_msg BOOL Play();
	afx_msg BSTR GetListDevice();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CTapiCtrl)
	void FireOnTimeOut()
		{FireEvent(eventidOnTimeOut,EVENT_PARAM(VTS_NONE));}
	void FireOnBusy()
		{FireEvent(eventidOnBusy,EVENT_PARAM(VTS_NONE));}
	void FireOnConnect()
		{FireEvent(eventidOnConnect,EVENT_PARAM(VTS_NONE));}
	void FireOnDisconnect(long dwParam2)
		{FireEvent(eventidOnDisconnect,EVENT_PARAM(VTS_I4), dwParam2);}
	void FireOnLineCallState(long dwParam1, long dwParam2, long dwParam3)
		{FireEvent(eventidOnLineCallState,EVENT_PARAM(VTS_I4  VTS_I4  VTS_I4), dwParam1, dwParam2, dwParam3);}
	void FireOnMessage(LPCTSTR strMessage, long dwCodeMSG)
		{FireEvent(eventidOnMessage,EVENT_PARAM(VTS_BSTR  VTS_I4), strMessage, dwCodeMSG);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	
	BOOL HangupCall();
	BOOL ShutDownTAPI();
	BOOL TapiInitialize();

	enum {
	//{{AFX_DISP_ID(CTapiCtrl)
	dispidLastError = 1L,
	dispidTapiInitialize = 2L,
	dispidWaitTimeOut = 3L,
	dispidDeviceID = 4L,
	dispidDial = 5L,
	dispidHangup = 6L,
	dispidPlayFile = 7L,
	dispidAddFileToPlayList = 8L,
	dispidClearPlayList = 9L,
	dispidPlay = 10L,
	dispidGetListDevice = 11L,
	eventidOnTimeOut = 1L,
	eventidOnBusy = 2L,
	eventidOnConnect = 3L,
	eventidOnDisconnect = 4L,
	eventidOnLineCallState = 5L,
	eventidOnMessage = 6L,
	//}}AFX_DISP_ID
	};
private:
		BOOL GetStringMSG(DWORD dwIDSParam);
	
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TAPICTL_H__5B40BA77_CC47_11D4_8A39_0050DACF7F4C__INCLUDED)
